Index: trunk/src/VBox/Devices/Network/SrvIntNetR0.cpp
===================================================================
--- trunk/src/VBox/Devices/Network/SrvIntNetR0.cpp	(revision 25301)
+++ trunk/src/VBox/Devices/Network/SrvIntNetR0.cpp	(revision 25336)
@@ -3410,25 +3410,10 @@
 
 
-#ifdef RT_WITH_W64_UNWIND_HACK
-# if defined(RT_OS_WINDOWS) && defined(RT_ARCH_AMD64)
-#  define INTNET_DECL_CALLBACK(type) DECLASM(DECLHIDDEN(type))
-#  define INTNET_CALLBACK(_n) intnetNtWrap##_n
-
-   /* wrapper callback declarations */
-   INTNET_DECL_CALLBACK(bool) INTNET_CALLBACK(intnetR0TrunkIfPortSetSGPhys)(PINTNETTRUNKSWPORT pSwitchPort, bool fEnable);
-   INTNET_DECL_CALLBACK(bool) INTNET_CALLBACK(intnetR0TrunkIfPortRecv)(PINTNETTRUNKSWPORT pSwitchPort, PINTNETSG pSG, uint32_t fSrc);
-   INTNET_DECL_CALLBACK(void) INTNET_CALLBACK(intnetR0TrunkIfPortSGRetain)(PINTNETTRUNKSWPORT pSwitchPort, PINTNETSG pSG);
-   INTNET_DECL_CALLBACK(void) INTNET_CALLBACK(intnetR0TrunkIfPortSGRelease)(PINTNETTRUNKSWPORT pSwitchPort, PINTNETSG pSG);
-
-# else
-#  error "UNSUPPORTED (RT_WITH_W64_UNWIND_HACK)"
-# endif
-#else
-#  define INTNET_DECL_CALLBACK(_t) static DECLCALLBACK(_t)
+#  define static DECLCALLBACK(_t) static DECLCALLBACK(_t)
 #  define INTNET_CALLBACK(_n) _n
 #endif
 
 /** @copydoc INTNETTRUNKSWPORT::pfnSetSGPhys */
-INTNET_DECL_CALLBACK(bool) intnetR0TrunkIfPortSetSGPhys(PINTNETTRUNKSWPORT pSwitchPort, bool fEnable)
+static DECLCALLBACK(bool) intnetR0TrunkIfPortSetSGPhys(PINTNETTRUNKSWPORT pSwitchPort, bool fEnable)
 {
     PINTNETTRUNKIF pThis = INTNET_SWITCHPORT_2_TRUNKIF(pSwitchPort);
@@ -3439,5 +3424,5 @@
 
 /** @copydoc INTNETTRUNKSWPORT::pfnRecv */
-INTNET_DECL_CALLBACK(bool) intnetR0TrunkIfPortRecv(PINTNETTRUNKSWPORT pSwitchPort, PINTNETSG pSG, uint32_t fSrc)
+static DECLCALLBACK(bool) intnetR0TrunkIfPortRecv(PINTNETTRUNKSWPORT pSwitchPort, PINTNETSG pSG, uint32_t fSrc)
 {
     PINTNETTRUNKIF pThis = INTNET_SWITCHPORT_2_TRUNKIF(pSwitchPort);
@@ -3470,5 +3455,5 @@
 
 /** @copydoc INTNETTRUNKSWPORT::pfnSGRetain */
-INTNET_DECL_CALLBACK(void) intnetR0TrunkIfPortSGRetain(PINTNETTRUNKSWPORT pSwitchPort, PINTNETSG pSG)
+static DECLCALLBACK(void) intnetR0TrunkIfPortSGRetain(PINTNETTRUNKSWPORT pSwitchPort, PINTNETSG pSG)
 {
     PINTNETTRUNKIF pThis = INTNET_SWITCHPORT_2_TRUNKIF(pSwitchPort);
@@ -3487,5 +3472,5 @@
 
 /** @copydoc INTNETTRUNKSWPORT::pfnSGRelease */
-INTNET_DECL_CALLBACK(void) intnetR0TrunkIfPortSGRelease(PINTNETTRUNKSWPORT pSwitchPort, PINTNETSG pSG)
+static DECLCALLBACK(void) intnetR0TrunkIfPortSGRelease(PINTNETTRUNKSWPORT pSwitchPort, PINTNETSG pSG)
 {
     PINTNETTRUNKIF pThis = INTNET_SWITCHPORT_2_TRUNKIF(pSwitchPort);
@@ -3721,8 +3706,8 @@
         return VERR_NO_MEMORY;
     pTrunkIF->SwitchPort.u32Version     = INTNETTRUNKSWPORT_VERSION;
-    pTrunkIF->SwitchPort.pfnSetSGPhys   = INTNET_CALLBACK(intnetR0TrunkIfPortSetSGPhys);
-    pTrunkIF->SwitchPort.pfnRecv        = INTNET_CALLBACK(intnetR0TrunkIfPortRecv);
-    pTrunkIF->SwitchPort.pfnSGRetain    = INTNET_CALLBACK(intnetR0TrunkIfPortSGRetain);
-    pTrunkIF->SwitchPort.pfnSGRelease   = INTNET_CALLBACK(intnetR0TrunkIfPortSGRelease);
+    pTrunkIF->SwitchPort.pfnSetSGPhys   = intnetR0TrunkIfPortSetSGPhys;
+    pTrunkIF->SwitchPort.pfnRecv        = intnetR0TrunkIfPortRecv;
+    pTrunkIF->SwitchPort.pfnSGRetain    = intnetR0TrunkIfPortSGRetain;
+    pTrunkIF->SwitchPort.pfnSGRelease   = intnetR0TrunkIfPortSGRelease;
     pTrunkIF->SwitchPort.u32VersionEnd  = INTNETTRUNKSWPORT_VERSION;
     //pTrunkIF->pIfPort = NULL;
Index: trunk/src/VBox/Devices/Network/win/SrvIntNetR0A-win.asm
===================================================================
--- trunk/src/VBox/Devices/Network/win/SrvIntNetR0A-win.asm	(revision 25301)
+++ 	(revision )
@@ -1,30 +1,0 @@
-; $Id$ */
-;; @file
-; Internal networking - The ring 0 service.
-;
-
-;
-; Copyright (C) 2006-2008 Sun Microsystems, Inc.
-;
-; This file is part of VirtualBox Open Source Edition (OSE), as
-; available from http://www.virtualbox.org. This file is free software;
-; you can redistribute it and/or modify it under the terms of the GNU
-; General Public License (GPL) as published by the Free Software
-; Foundation, in version 2 as it comes in the "COPYING" file of the
-; VirtualBox OSE distribution. VirtualBox OSE is distributed in the
-; hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
-;
-; Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
-; Clara, CA 95054 USA or visit http://www.sun.com if you need
-; additional information or have any questions.
-;
-
-%define IN_DYNAMICLOAD_CODE
-
-%include "iprt/ntwrap.mac"
-
-NtWrapDrv2DynFunctionWithAllRegParams intnetNtWrap, intnetR0TrunkIfPortSetSGPhys
-NtWrapDrv2DynFunctionWithAllRegParams intnetNtWrap, intnetR0TrunkIfPortRecv
-NtWrapDrv2DynFunctionWithAllRegParams intnetNtWrap, intnetR0TrunkIfPortSGRetain
-NtWrapDrv2DynFunctionWithAllRegParams intnetNtWrap, intnetR0TrunkIfPortSGRelease
-