Index: /trunk/Config.kmk
===================================================================
--- /trunk/Config.kmk	(revision 25456)
+++ /trunk/Config.kmk	(revision 25457)
@@ -1610,4 +1610,16 @@
   VBOX_LIB_OGL_CRUTIL = $(VBOX_PATH_ADDITIONS)/VBoxOGLcrutil$(VBOX_SUFF_DLL)
   VBOX_LIB_OGL_HOSTCRUTIL = $(PATH_BIN)/VBoxOGLhostcrutil$(VBOX_SUFF_DLL)
+ endif
+
+ if1of ($(KBUILD_TARGET),linux solaris)
+ # VBOX_PATH_MESA_SOURCE = $(PATH_ROOT)/src/libs/mesa-7.2
+  VBOX_PATH_MESA_SOURCE = $(VBOX_PATH_X11_ROOT)/mesa-7.2
+  VBOX_MESA_INCS = \
+        $(VBOX_PATH_MESA_SOURCE) \
+        $(VBOX_PATH_MESA_SOURCE)/include \
+        $(VBOX_PATH_MESA_SOURCE)/src/mesa/ \
+        $(VBOX_PATH_MESA_SOURCE)/src/mesa/glapi \
+        $(VBOX_PATH_MESA_SOURCE)/src/mesa/main \
+        $(VBOX_PATH_MESA_SOURCE)/src/mesa/drivers/dri/common
  endif
 
Index: /trunk/src/VBox/Additions/common/crOpenGL/Makefile.kmk
===================================================================
--- /trunk/src/VBox/Additions/common/crOpenGL/Makefile.kmk	(revision 25456)
+++ /trunk/src/VBox/Additions/common/crOpenGL/Makefile.kmk	(revision 25457)
@@ -50,6 +50,4 @@
   VBoxOGL_FAKEDRI = 1
  endif
-# VBOX_PATH_MESA_SOURCE = $(PATH_ROOT)/src/libs/mesa-7.2
- VBOX_PATH_MESA_SOURCE = $(VBOX_PATH_X11_ROOT)/mesa-7.2
 
  # Only Solaris right now needs C stubs because I can't figure out how to
@@ -78,10 +76,5 @@
 	$(VBOX_PATH_X11_ROOT)/libx11-1.1.5-other \
 	$(VBOX_PATH_X11_ROOT)/1.3/xorg \
-	$(VBOX_PATH_MESA_SOURCE) \
-	$(VBOX_PATH_MESA_SOURCE)/include \
-	$(VBOX_PATH_MESA_SOURCE)/src/mesa/ \
-	$(VBOX_PATH_MESA_SOURCE)/src/mesa/glapi \
-	$(VBOX_PATH_MESA_SOURCE)/src/mesa/main \
-	$(VBOX_PATH_MESA_SOURCE)/src/mesa/drivers/dri/common \
+	$(VBOX_MESA_INCS) \
 	$(PATH_ROOT)/src/VBox/Additions/x11/x11include/libdrm-2.4.13
  VBoxOGL_DEFS     += VBOX_NO_NATIVEGL
@@ -326,4 +319,8 @@
 VBoxOGLarrayspu_INCS          = \
 	array
+if1of ($(KBUILD_TARGET),linux solaris)
+ VBoxOGLarrayspu_INCS += \
+        $(VBOX_MESA_INCS)
+endif
 VBoxOGLarrayspu_INCS.darwin  += $(PATH_OUT)/obj/VBoxOGL
 VBoxOGLarrayspu_INTERMEDIATES = \
@@ -348,4 +345,8 @@
 VBoxOGLpassthroughspu_INCS        = \
 	passthrough
+if1of ($(KBUILD_TARGET),linux solaris)
+ VBoxOGLpassthroughspu_INCS += \
+        $(VBOX_MESA_INCS)
+endif
 VBoxOGLpassthroughspu_SOURCES     = \
 	passthrough/passthroughspu_init.c \
@@ -373,4 +374,8 @@
 VBoxOGLpackspu_INCS          = \
 	pack
+if1of ($(KBUILD_TARGET),linux solaris)
+ VBoxOGLpackspu_INCS += \
+        $(VBOX_MESA_INCS)
+endif
 VBoxOGLpackspu_INTERMEDIATES = \
 	$(VBOX_PATH_CROGL_GENFILES)/packspu_proto.h \
@@ -439,4 +444,8 @@
 VBoxOGLfeedbackspu_INCS        = \
 	feedback
+if1of ($(KBUILD_TARGET),linux solaris)
+ VBoxOGLfeedbackspu_INCS += \
+        $(VBOX_MESA_INCS)
+endif
 VBoxOGLarrayspu_INTERMEDIATES = \
 	$(VBOX_PATH_CROGL_GENFILES)/feedbackspu_proto.h
Index: /trunk/src/VBox/GuestHost/OpenGL/Makefile.kmk
===================================================================
--- /trunk/src/VBox/GuestHost/OpenGL/Makefile.kmk	(revision 25456)
+++ /trunk/src/VBox/GuestHost/OpenGL/Makefile.kmk	(revision 25457)
@@ -47,4 +47,8 @@
 VBoxOGLcrutil_SDKS.win      = DXSDK
 VBoxOGLcrutil_INTERMEDIATES = $(VBOX_PATH_CROGL_GENFILES)/cr_opcodes.h
+if1of ($(KBUILD_TARGET),linux solaris)
+ VBoxOGLcrutil_INCS += \
+	$(VBOX_MESA_INCS)
+endif
 VBoxOGLcrutil_SOURCES       = \
 	util/bbox.c \
@@ -120,4 +124,8 @@
 VBoxOGLcrpacker_INCS = \
 	packer
+if1of ($(KBUILD_TARGET),linux solaris)
+ VBoxOGLcrpacker_INCS += \
+	$(VBOX_MESA_INCS)
+endif
 VBoxOGLcrpacker_INTERMEDIATES = \
 	$(VBOX_PATH_CROGL_GENFILES)/cr_packfunctions.h \
@@ -250,4 +258,8 @@
 VBoxOGLspuload_INTERMEDIATES = \
 	$(VBOX_PATH_CROGL_GENFILES)/spu_dispatch_table.h
+if1of ($(KBUILD_TARGET),linux solaris)
+ VBoxOGLspuload_INCS += \
+	$(VBOX_MESA_INCS)
+endif
 VBoxOGLspuload_SOURCES = \
 	spu_loader/spuinit.c \
@@ -301,4 +313,8 @@
 VBoxOGLcrstate_INCS = \
 	state_tracker
+if1of ($(KBUILD_TARGET),linux solaris)
+ VBoxOGLcrstate_INCS += \
+	$(VBOX_MESA_INCS)
+endif
 VBoxOGLcrstate_INTERMEDIATES = \
 	$(VBOX_PATH_CROGL_GENFILES)/state/cr_statefuncs.h \
@@ -464,4 +480,8 @@
 VBoxOGLerrorspu_INTERMEDIATES = \
 	$(VBOX_PATH_CROGL_GENFILES)/spu_dispatch_table.h
+if1of ($(KBUILD_TARGET),linux solaris)
+ VBoxOGLerrorspu_INCS += \
+	$(VBOX_MESA_INCS)
+endif
 VBoxOGLerrorspu_SOURCES = \
 	$(VBOX_PATH_CROGL_GENFILES)/errorspu.c \